const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const purchase_order_lines = sequelize.define(
    'purchase_order_lines',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

ordered_quantity: {
        type: DataTypes.DECIMAL,
      
      

      },

unit_price: {
        type: DataTypes.DECIMAL,
      
      

      },

need_by_at: {
        type: DataTypes.DATE,
      
      

      },

line_notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  purchase_order_lines.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity




































//end loop



    db.purchase_order_lines.belongsTo(db.purchase_orders, {
      as: 'purchase_order',
      foreignKey: {
        name: 'purchase_orderId',
      },
      constraints: false,
    });

    db.purchase_order_lines.belongsTo(db.materials, {
      as: 'material',
      foreignKey: {
        name: 'materialId',
      },
      constraints: false,
    });

    db.purchase_order_lines.belongsTo(db.units_of_measure, {
      as: 'uom',
      foreignKey: {
        name: 'uomId',
      },
      constraints: false,
    });




    db.purchase_order_lines.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.purchase_order_lines.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return purchase_order_lines;
};


